import PropTypes from 'prop-types';
import { useState, useRef, createRef, useCallback } from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
var DEFAULT_LENGTH = 6;
var BASE_CLASS = 'sui-AtomValidationCode';
var INPUT_MAX_NUMBER = 10;

var noop = function noop() {};

export default function AtomValidationCode(_ref) {
  var _ref$onChange = _ref.onChange,
      onChange = _ref$onChange === void 0 ? noop : _ref$onChange,
      _ref$length = _ref.length,
      length = _ref$length === void 0 ? DEFAULT_LENGTH : _ref$length;

  var _useState = useState(new Array(length).fill(null)),
      numbers = _useState[0],
      setNumbers = _useState[1];

  var numberRefs = useRef([]);
  numberRefs.current = numbers.map(function (_, i) {
    var _numberRefs$current$i;

    return (_numberRefs$current$i = numberRefs.current[i]) != null ? _numberRefs$current$i : /*#__PURE__*/createRef();
  });
  var handleChange = useCallback(function (_ref2) {
    var ev = _ref2.ev,
        i = _ref2.i;
    var value = ev.target.value;

    if (value < INPUT_MAX_NUMBER) {
      var numberArray = [].concat(numbers);
      numberArray[i] = value;
      setNumbers(numberArray);
      onChange(ev, {
        value: numberArray.join('')
      });
    }

    if (value !== '') {
      var nextInput = numberRefs.current[i + 1];
      nextInput ? nextInput.current.focus() : numberRefs.current[i].current.blur();
    }
  }, [numbers, onChange]);
  return /*#__PURE__*/_jsx("div", {
    className: BASE_CLASS,
    children: /*#__PURE__*/_jsx("div", {
      className: BASE_CLASS + "-code",
      children: numbers.map(function (_, i) {
        return /*#__PURE__*/_jsx("input", {
          autoComplete: "one-time-code",
          autoFocus: i === 0,
          className: BASE_CLASS + "-input",
          inputMode: "numeric",
          onChange: function onChange(ev) {
            return handleChange({
              ev: ev,
              i: i
            });
          },
          onClick: function onClick(ev) {
            return ev.target.select();
          },
          ref: numberRefs.current[i],
          type: "number",
          value: numbers[i]
        }, i);
      })
    })
  });
}
AtomValidationCode.displayName = 'AtomValidationCode';